(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@ng-web-apis/audio', ['exports', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global["ng-web-apis"] = global["ng-web-apis"] || {}, global["ng-web-apis"].audio = {}), global.ng.core, global.rxjs, global.rxjs.operators));
})(this, (function (exports, i0, rxjs, operators) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    function processAudioParam(param, value, currentTime) {
        if (currentTime === void 0) { currentTime = 0; }
        if (param.cancelAndHoldAtTime) {
            param.cancelAndHoldAtTime(currentTime);
        }
        else {
            param.cancelScheduledValues(currentTime);
            param.setValueAtTime(guard(param.value), currentTime);
        }
        if (typeof value === 'number') {
            param.setValueAtTime(guard(value), currentTime);
            return;
        }
        if (value instanceof Array) {
            processSchedule(param, value, currentTime);
            return;
        }
        if (!('mode' in value)) {
            param.setValueCurveAtTime(value.value, currentTime, value.duration);
            return;
        }
        param.setValueAtTime(guard(param.value), currentTime);
        processAutomation(param, value, currentTime);
    }
    function processSchedule(param, value, currentTime) {
        value.forEach(function (automation) {
            if ('mode' in automation) {
                processAutomation(param, automation, currentTime);
            }
            else {
                param.setValueCurveAtTime(automation.value, currentTime, automation.duration);
            }
            currentTime += automation.duration;
        });
    }
    function processAutomation(param, _a, currentTime) {
        var value = _a.value, _b = _a.mode, mode = _b === void 0 ? 'instant' : _b, duration = _a.duration;
        switch (mode) {
            case 'instant':
                param.setValueAtTime(guard(value), currentTime);
                param.setValueAtTime(guard(value), currentTime + duration);
                break;
            case 'exponential':
                if (value < 0 || value * param.value < 0) {
                    param.linearRampToValueAtTime(guard(value), currentTime + duration);
                }
                else {
                    param.exponentialRampToValueAtTime(guard(value), currentTime + duration);
                }
                param.setValueAtTime(guard(value), currentTime + duration);
                break;
            case 'linear':
                param.linearRampToValueAtTime(guard(value), currentTime + duration);
                break;
        }
    }
    function guard(v) {
        return v || 0.00000001;
    }

    function audioParam(param) {
        if (param === void 0) { param = ''; }
        var decorator = function (target, propertyKey) {
            Object.defineProperty(target, propertyKey, {
                set: function (value) {
                    value = typeof value === 'string' ? Number.parseFloat(value) : value;
                    var audioParam = this instanceof AudioWorkletNode
                        ? this.parameters.get(propertyKey)
                        : this[param];
                    if (audioParam instanceof AudioParam) {
                        processAudioParam(audioParam, value, this.context.currentTime);
                    }
                    else {
                        // Fallback for older browsers
                        Object.defineProperty(target, propertyKey, { value: value });
                    }
                },
            });
        };
        return decorator;
    }

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
        function accept(f) { if (f !== void 0 && typeof f !== "function")
            throw new TypeError("Function expected"); return f; }
        var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
        var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
        var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
        var _, done = false;
        for (var i = decorators.length - 1; i >= 0; i--) {
            var context = {};
            for (var p in contextIn)
                context[p] = p === "access" ? {} : contextIn[p];
            for (var p in contextIn.access)
                context.access[p] = contextIn.access[p];
            context.addInitializer = function (f) { if (done)
                throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
            var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
            if (kind === "accessor") {
                if (result === void 0)
                    continue;
                if (result === null || typeof result !== "object")
                    throw new TypeError("Object expected");
                if (_ = accept(result.get))
                    descriptor.get = _;
                if (_ = accept(result.set))
                    descriptor.set = _;
                if (_ = accept(result.init))
                    initializers.push(_);
            }
            else if (_ = accept(result)) {
                if (kind === "field")
                    initializers.push(_);
                else
                    descriptor[key] = _;
            }
        }
        if (target)
            Object.defineProperty(target, contextIn.name, descriptor);
        done = true;
    }
    ;
    function __runInitializers(thisArg, initializers, value) {
        var useValue = arguments.length > 2;
        for (var i = 0; i < initializers.length; i++) {
            value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
        }
        return useValue ? value : void 0;
    }
    ;
    function __propKey(x) {
        return typeof x === "symbol" ? x : "".concat(x);
    }
    ;
    function __setFunctionName(f, name, prefix) {
        if (typeof name === "symbol")
            name = name.description ? "[".concat(name.description, "]") : "";
        return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
    }
    ;
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }

    var AUDIO_CONTEXT = new i0.InjectionToken('Web Audio API context', {
        providedIn: 'root',
        factory: function () { return new AudioContext(); },
    });

    function latencyHintFactory(latencyHint) {
        return latencyHint === null
            ? undefined
            : Number.parseFloat(latencyHint) || latencyHint;
    }

    var WebAudioContext = /** @class */ (function (_super) {
        __extends(WebAudioContext, _super);
        function WebAudioContext(latencyHint, sampleRate) {
            return _super.call(this, {
                latencyHint: latencyHintFactory(latencyHint),
                sampleRate: parseInt(sampleRate || '', 10) || undefined,
            }) || this;
        }
        WebAudioContext.prototype.ngOnDestroy = function () {
            this.close();
        };
        return WebAudioContext;
    }(AudioContext));
    WebAudioContext.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioContext, deps: [{ token: 'latencyHint', attribute: true }, { token: 'sampleRate', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioContext.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioContext, selector: "[waAudioContext]", providers: [
            {
                provide: AUDIO_CONTEXT,
                useExisting: i0.forwardRef(function () { return WebAudioContext; }),
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioContext, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waAudioContext]',
                        providers: [
                            {
                                provide: AUDIO_CONTEXT,
                                useExisting: i0.forwardRef(function () { return WebAudioContext; }),
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['latencyHint']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['sampleRate']
                        }] }];
        } });

    /**
     * This is mostly for internal use only
     */
    var CONSTRUCTOR_SUPPORT = new i0.InjectionToken('Tests if constructor mode of node creation is supported or a fallback to factory method is needed', {
        providedIn: 'root',
        factory: function () {
            try {
                return !!new GainNode(i0.inject(AUDIO_CONTEXT));
            }
            catch (_) {
                return false;
            }
        },
    });

    var WebAudioChannel = /** @class */ (function (_super) {
        __extends(WebAudioChannel, _super);
        function WebAudioChannel(context, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context) || this;
            }
            else {
                var result = context.createGain();
                Object.setPrototypeOf(result, WebAudioChannel.prototype);
                return result;
            }
            return _this;
        }
        WebAudioChannel.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioChannel;
    }(GainNode));
    WebAudioChannel.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioChannel, deps: [{ token: AUDIO_CONTEXT }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioChannel.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioChannel, selector: "[waChannel]", exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioChannel, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waChannel]',
                        exportAs: 'AudioNode',
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        } });

    var POLLING_TIME = 100;

    var AUDIO_NODE = new i0.InjectionToken('Web Audio API audio node', {
        factory: function () { return null; },
    });
    function asAudioNode(useExisting) {
        return {
            provide: AUDIO_NODE,
            useExisting: useExisting,
        };
    }

    function connect(source, destination) {
        if (source && destination) {
            // @ts-ignore TS does not have a union override for connect method
            source.connect(destination);
        }
    }

    var WebAudioDestination = /** @class */ (function (_super) {
        __extends(WebAudioDestination, _super);
        function WebAudioDestination(context, node, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context) || this;
                WebAudioDestination.init(_this, node);
            }
            else {
                var result = context.createAnalyser();
                Object.setPrototypeOf(result, WebAudioDestination.prototype);
                WebAudioDestination.init(result, node);
                return result;
            }
            return _this;
        }
        WebAudioDestination.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        WebAudioDestination.prototype.isSilent = function (array) {
            return Math.abs(array.reduce(function (acc, cur) { return acc + cur; }, 0)) < 0.001;
        };
        WebAudioDestination.init = function (that, node) {
            connect(node, that);
            that.fftSize = 256;
            that.connect(that.context.destination);
            that.quiet = rxjs.interval(POLLING_TIME).pipe(operators.mapTo(new Float32Array(that.fftSize)), operators.tap(function (array) { return that.getFloatTimeDomainData(array); }), operators.map(function (array) { return that.isSilent(array); }), operators.distinctUntilChanged(), operators.skipWhile(function (isSilent) { return isSilent; }), operators.debounceTime(5000), operators.filter(function (isSilent) { return isSilent; }));
        };
        return WebAudioDestination;
    }(AnalyserNode));
    WebAudioDestination.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioDestination, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioDestination.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioDestination, selector: "[waAudioDestinationNode]", outputs: { quiet: "quiet" }, exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioDestination, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waAudioDestinationNode]',
                        exportAs: 'AudioNode',
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        }, propDecorators: { quiet: [{
                    type: i0.Output
                }] } });

    function fallbackAudioParam(value) {
        if (!value) {
            return 0;
        }
        if (typeof value === 'number') {
            return value;
        }
        if (value instanceof Array) {
            var last = value[value.length - 1].value;
            return typeof last === 'number' ? last : last[last.length - 1];
        }
        if (value.value instanceof Array) {
            return value.value[value.value.length - 1];
        }
        return value.value;
    }

    var WebAudioListener = /** @class */ (function (_super) {
        __extends(WebAudioListener, _super);
        function WebAudioListener(context, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context) || this;
            }
            else {
                var result = context.createGain();
                Object.setPrototypeOf(result, WebAudioListener.prototype);
                return result;
            }
            return _this;
        }
        Object.defineProperty(WebAudioListener.prototype, "forwardX", {
            get: function () {
                return this.context.listener.forwardX;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "forwardY", {
            get: function () {
                return this.context.listener.forwardY;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "forwardZ", {
            get: function () {
                return this.context.listener.forwardZ;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "positionX", {
            get: function () {
                return this.context.listener.positionX;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "positionY", {
            get: function () {
                return this.context.listener.positionY;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "positionZ", {
            get: function () {
                return this.context.listener.positionZ;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "upX", {
            get: function () {
                return this.context.listener.upX;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "upY", {
            get: function () {
                return this.context.listener.upY;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WebAudioListener.prototype, "upZ", {
            get: function () {
                return this.context.listener.upZ;
            },
            enumerable: false,
            configurable: true
        });
        WebAudioListener.prototype.ngOnChanges = function () {
            if (this.context.listener.positionX instanceof AudioParam) {
                return;
            }
            // Fallback for older browsers
            this.context.listener.setOrientation(fallbackAudioParam(this.forwardXParam), fallbackAudioParam(this.forwardYParam), fallbackAudioParam(this.forwardZParam), fallbackAudioParam(this.upXParam), fallbackAudioParam(this.upYParam), fallbackAudioParam(this.upZParam));
            this.context.listener.setPosition(fallbackAudioParam(this.positionXParam), fallbackAudioParam(this.positionYParam), fallbackAudioParam(this.positionZParam));
        };
        return WebAudioListener;
    }(GainNode));
    WebAudioListener.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioListener, deps: [{ token: AUDIO_CONTEXT, self: true }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioListener.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioListener, selector: "[waAudioContext],[waOfflineAudioContext][length][sampleRate]", inputs: { forwardXParam: ["forwardX", "forwardXParam"], forwardYParam: ["forwardY", "forwardYParam"], forwardZParam: ["forwardZ", "forwardZParam"], positionXParam: ["positionX", "positionXParam"], positionYParam: ["positionY", "positionYParam"], positionZParam: ["positionZ", "positionZParam"], upXParam: ["upX", "upXParam"], upYParam: ["upY", "upYParam"], upZParam: ["upZ", "upZParam"] }, usesInheritance: true, usesOnChanges: true, ngImport: i0__namespace });
    __decorate([
        audioParam('forwardX')
    ], WebAudioListener.prototype, "forwardXParam", void 0);
    __decorate([
        audioParam('forwardY')
    ], WebAudioListener.prototype, "forwardYParam", void 0);
    __decorate([
        audioParam('forwardZ')
    ], WebAudioListener.prototype, "forwardZParam", void 0);
    __decorate([
        audioParam('positionX')
    ], WebAudioListener.prototype, "positionXParam", void 0);
    __decorate([
        audioParam('positionY')
    ], WebAudioListener.prototype, "positionYParam", void 0);
    __decorate([
        audioParam('positionZ')
    ], WebAudioListener.prototype, "positionZParam", void 0);
    __decorate([
        audioParam('upX')
    ], WebAudioListener.prototype, "upXParam", void 0);
    __decorate([
        audioParam('upY')
    ], WebAudioListener.prototype, "upYParam", void 0);
    __decorate([
        audioParam('upZ')
    ], WebAudioListener.prototype, "upZParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioListener, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waAudioContext],[waOfflineAudioContext][length][sampleRate]',
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Self
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        }, propDecorators: { forwardXParam: [{
                    type: i0.Input,
                    args: ['forwardX']
                }], forwardYParam: [{
                    type: i0.Input,
                    args: ['forwardY']
                }], forwardZParam: [{
                    type: i0.Input,
                    args: ['forwardZ']
                }], positionXParam: [{
                    type: i0.Input,
                    args: ['positionX']
                }], positionYParam: [{
                    type: i0.Input,
                    args: ['positionY']
                }], positionZParam: [{
                    type: i0.Input,
                    args: ['positionZ']
                }], upXParam: [{
                    type: i0.Input,
                    args: ['upX']
                }], upYParam: [{
                    type: i0.Input,
                    args: ['upY']
                }], upZParam: [{
                    type: i0.Input,
                    args: ['upZ']
                }] } });

    var WebAudioOfflineContext = /** @class */ (function (_super) {
        __extends(WebAudioOfflineContext, _super);
        function WebAudioOfflineContext(length, sampleRate, numberOfChannels, autoplay) {
            var _this = _super.call(this, parseInt(numberOfChannels || '', 10) || 1, parseInt(length, 10), parseInt(sampleRate, 10)) || this;
            _this.complete = new i0.EventEmitter();
            _this.oncomplete = function (_a) {
                var renderedBuffer = _a.renderedBuffer;
                return _this.complete.emit(renderedBuffer);
            };
            if (autoplay !== null) {
                _this.startRendering();
            }
            return _this;
        }
        return WebAudioOfflineContext;
    }(OfflineAudioContext));
    WebAudioOfflineContext.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioOfflineContext, deps: [{ token: 'length', attribute: true }, { token: 'sampleRate', attribute: true }, { token: 'numberOfChannels', attribute: true }, { token: 'autoplay', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioOfflineContext.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioOfflineContext, selector: "[waOfflineAudioContext][length][sampleRate]", outputs: { complete: "complete" }, providers: [
            {
                provide: AUDIO_CONTEXT,
                useExisting: i0.forwardRef(function () { return WebAudioOfflineContext; }),
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioOfflineContext, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waOfflineAudioContext][length][sampleRate]',
                        providers: [
                            {
                                provide: AUDIO_CONTEXT,
                                useExisting: i0.forwardRef(function () { return WebAudioOfflineContext; }),
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['length']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['sampleRate']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['numberOfChannels']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['autoplay']
                        }] }];
        }, propDecorators: { complete: [{
                    type: i0.Output
                }] } });

    var WebAudioOutput = /** @class */ (function (_super) {
        __extends(WebAudioOutput, _super);
        function WebAudioOutput(context, node, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context) || this;
                connect(node, _this);
            }
            else {
                var result = context.createGain();
                Object.setPrototypeOf(result, WebAudioOutput.prototype);
                connect(node, result);
                return result;
            }
            return _this;
        }
        Object.defineProperty(WebAudioOutput.prototype, "waOutput", {
            set: function (destination) {
                this.disconnect();
                connect(this, destination);
            },
            enumerable: false,
            configurable: true
        });
        WebAudioOutput.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        WebAudioOutput.init = function (that, node) {
            connect(node, that);
        };
        return WebAudioOutput;
    }(GainNode));
    WebAudioOutput.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioOutput, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioOutput.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioOutput, selector: "[waOutput]", inputs: { waOutput: "waOutput" }, usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioOutput, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waOutput]',
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        }, propDecorators: { waOutput: [{
                    type: i0.Input
                }] } });

    var WebAudioMediaStreamDestination = /** @class */ (function (_super) {
        __extends(WebAudioMediaStreamDestination, _super);
        function WebAudioMediaStreamDestination(context, node, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context) || this;
                connect(node, _this);
            }
            else {
                var result = context.createMediaStreamDestination();
                Object.setPrototypeOf(result, WebAudioMediaStreamDestination.prototype);
                connect(node, result);
                return result;
            }
            return _this;
        }
        return WebAudioMediaStreamDestination;
    }(MediaStreamAudioDestinationNode));
    WebAudioMediaStreamDestination.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioMediaStreamDestination, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioMediaStreamDestination.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioMediaStreamDestination, selector: "[waMediaStreamAudioDestinationNode]", exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioMediaStreamDestination, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waMediaStreamAudioDestinationNode]',
                        exportAs: 'AudioNode',
                    }]
            }], ctorParameters: function () {
            return [{ type: AudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        } });

    function parse(value, fallback) {
        var parsed = parseFloat(value || '');
        return isNaN(parsed) ? fallback : parsed;
    }

    var WebAudioAnalyser = /** @class */ (function (_super) {
        __extends(WebAudioAnalyser, _super);
        function WebAudioAnalyser(context, node, modern, fftSizeArg, maxDecibelsArg, minDecibelsArg, smoothingTimeConstantArg) {
            var _this = this;
            var fftSize = parse(fftSizeArg, 2048);
            var maxDecibels = parse(maxDecibelsArg, -30);
            var minDecibels = parse(minDecibelsArg, -100);
            var smoothingTimeConstant = parse(smoothingTimeConstantArg, 0.8);
            if (modern) {
                _this = _super.call(this, context, { fftSize: fftSize, maxDecibels: maxDecibels, minDecibels: minDecibels, smoothingTimeConstant: smoothingTimeConstant }) || this;
                WebAudioAnalyser.init(_this, node);
            }
            else {
                var result = context.createAnalyser();
                Object.setPrototypeOf(result, WebAudioAnalyser.prototype);
                WebAudioAnalyser.init(result, node);
                result.fftSize = fftSize;
                result.maxDecibels = maxDecibels;
                result.minDecibels = minDecibels;
                result.smoothingTimeConstant = smoothingTimeConstant;
                return result;
            }
            return _this;
        }
        WebAudioAnalyser.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        WebAudioAnalyser.init = function (that, node) {
            connect(node, that);
            var freqByte = new Uint8Array(that.frequencyBinCount);
            var freqFloat = new Float32Array(that.frequencyBinCount);
            var timeByte = new Uint8Array(that.fftSize);
            var timeFloat = new Float32Array(that.fftSize);
            that.frequencyByte$ = rxjs.interval(0, rxjs.animationFrameScheduler).pipe(operators.map(function () {
                if (freqByte.length !== that.frequencyBinCount) {
                    freqByte = new Uint8Array(that.frequencyBinCount);
                }
                that.getByteFrequencyData(freqByte);
                return freqByte;
            }), operators.share());
            that.frequencyFloat$ = rxjs.interval(0, rxjs.animationFrameScheduler).pipe(operators.map(function () {
                if (freqFloat.length !== that.frequencyBinCount) {
                    freqFloat = new Float32Array(that.frequencyBinCount);
                }
                that.getFloatFrequencyData(freqFloat);
                return freqFloat;
            }), operators.share());
            that.timeByte$ = rxjs.interval(0, rxjs.animationFrameScheduler).pipe(operators.map(function () {
                if (timeByte.length !== that.fftSize) {
                    timeByte = new Uint8Array(that.frequencyBinCount);
                }
                that.getByteTimeDomainData(timeByte);
                return timeByte;
            }), operators.share());
            that.timeFloat$ = rxjs.interval(0, rxjs.animationFrameScheduler).pipe(operators.map(function () {
                if (timeFloat.length !== that.fftSize) {
                    timeFloat = new Float32Array(that.frequencyBinCount);
                }
                that.getFloatTimeDomainData(timeFloat);
                return timeFloat;
            }), operators.share());
        };
        return WebAudioAnalyser;
    }(AnalyserNode));
    WebAudioAnalyser.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioAnalyser, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: CONSTRUCTOR_SUPPORT }, { token: 'fftSize', attribute: true }, { token: 'maxDecibels', attribute: true }, { token: 'minDecibels', attribute: true }, { token: 'smoothingTimeConstant', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioAnalyser.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioAnalyser, selector: "[waAnalyserNode]", inputs: { fftSize: "fftSize", minDecibels: "minDecibels", maxDecibels: "maxDecibels", smoothingTimeConstant: "smoothingTimeConstant", channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation" }, outputs: { frequencyByte$: "frequencyByte$", frequencyFloat$: "frequencyFloat$", timeByte$: "timeByte$", timeFloat$: "timeFloat$" }, providers: [asAudioNode(WebAudioAnalyser)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioAnalyser, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waAnalyserNode]',
                        exportAs: 'AudioNode',
                        inputs: [
                            'fftSize',
                            'minDecibels',
                            'maxDecibels',
                            'smoothingTimeConstant',
                            'channelCount',
                            'channelCountMode',
                            'channelInterpretation',
                        ],
                        providers: [asAudioNode(WebAudioAnalyser)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['fftSize']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['maxDecibels']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['minDecibels']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['smoothingTimeConstant']
                        }] }];
        }, propDecorators: { frequencyByte$: [{
                    type: i0.Output
                }], frequencyFloat$: [{
                    type: i0.Output
                }], timeByte$: [{
                    type: i0.Output
                }], timeFloat$: [{
                    type: i0.Output
                }] } });

    var WebAudioBiquadFilter = /** @class */ (function (_super) {
        __extends(WebAudioBiquadFilter, _super);
        function WebAudioBiquadFilter(context, modern, node, detuneArg, frequencyArg, gainArg, QArg) {
            var _this = this;
            var detune = parse(detuneArg, 0);
            var frequency = parse(frequencyArg, 350);
            var gain = parse(gainArg, 0);
            var Q = parse(QArg, 1);
            if (modern) {
                _this = _super.call(this, context, { detune: detune, frequency: frequency, gain: gain, Q: Q }) || this;
                connect(node, _this);
            }
            else {
                var result = context.createBiquadFilter();
                Object.setPrototypeOf(result, WebAudioBiquadFilter.prototype);
                result.detune.value = detune;
                result.frequency.value = frequency;
                result.gain.value = gain;
                result.Q.value = Q;
                connect(node, result);
                return result;
            }
            return _this;
        }
        WebAudioBiquadFilter.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        WebAudioBiquadFilter.init = function (that, node) {
            connect(node, that);
        };
        return WebAudioBiquadFilter;
    }(BiquadFilterNode));
    WebAudioBiquadFilter.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioBiquadFilter, deps: [{ token: AUDIO_CONTEXT }, { token: CONSTRUCTOR_SUPPORT }, { token: AUDIO_NODE, skipSelf: true }, { token: 'detune', attribute: true }, { token: 'frequency', attribute: true }, { token: 'gain', attribute: true }, { token: 'Q', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioBiquadFilter.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioBiquadFilter, selector: "[waBiquadFilterNode]", inputs: { type: "type", channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", detuneParam: ["detune", "detuneParam"], frequencyParam: ["frequency", "frequencyParam"], gainParam: ["gain", "gainParam"], qParam: ["Q", "qParam"] }, providers: [asAudioNode(WebAudioBiquadFilter)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    __decorate([
        audioParam('detune')
    ], WebAudioBiquadFilter.prototype, "detuneParam", void 0);
    __decorate([
        audioParam('frequency')
    ], WebAudioBiquadFilter.prototype, "frequencyParam", void 0);
    __decorate([
        audioParam('gain')
    ], WebAudioBiquadFilter.prototype, "gainParam", void 0);
    __decorate([
        audioParam('Q')
    ], WebAudioBiquadFilter.prototype, "qParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioBiquadFilter, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waBiquadFilterNode]',
                        exportAs: 'AudioNode',
                        inputs: ['type', 'channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioBiquadFilter)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['detune']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['frequency']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['gain']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['Q']
                        }] }];
        }, propDecorators: { detuneParam: [{
                    type: i0.Input,
                    args: ['detune']
                }], frequencyParam: [{
                    type: i0.Input,
                    args: ['frequency']
                }], gainParam: [{
                    type: i0.Input,
                    args: ['gain']
                }], qParam: [{
                    type: i0.Input,
                    args: ['Q']
                }] } });

    var WebAudioChannelMerger = /** @class */ (function (_super) {
        __extends(WebAudioChannelMerger, _super);
        function WebAudioChannelMerger(inputs, context, modern) {
            var _this = this;
            var numberOfInputs = parseInt(inputs || '', 10) || 6;
            if (modern) {
                _this = _super.call(this, context, { numberOfInputs: numberOfInputs }) || this;
            }
            else {
                var result = context.createChannelMerger(numberOfInputs);
                Object.setPrototypeOf(result, WebAudioChannelMerger.prototype);
                return result;
            }
            return _this;
        }
        Object.defineProperty(WebAudioChannelMerger.prototype, "channels", {
            set: function (channels) {
                var _this = this;
                channels.forEach(function (node, index) {
                    node.connect(_this, 0, index);
                });
            },
            enumerable: false,
            configurable: true
        });
        WebAudioChannelMerger.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioChannelMerger;
    }(ChannelMergerNode));
    WebAudioChannelMerger.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioChannelMerger, deps: [{ token: 'numberOfInputs', attribute: true }, { token: AUDIO_CONTEXT }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioChannelMerger.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioChannelMerger, selector: "[waChannelMergerNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation" }, providers: [asAudioNode(WebAudioChannelMerger)], queries: [{ propertyName: "channels", predicate: WebAudioChannel }], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioChannelMerger, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waChannelMergerNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioChannelMerger)],
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['numberOfInputs']
                        }] }, { type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        }, propDecorators: { channels: [{
                    type: i0.ContentChildren,
                    args: [WebAudioChannel, { descendants: false }]
                }] } });

    var WebAudioChannelSplitter = /** @class */ (function (_super) {
        __extends(WebAudioChannelSplitter, _super);
        function WebAudioChannelSplitter(outputs, context, node, modern) {
            var _this = this;
            var numberOfOutputs = parseInt(outputs || '', 10) || 6;
            if (modern) {
                _this = _super.call(this, context, { numberOfOutputs: numberOfOutputs }) || this;
                connect(node, _this);
            }
            else {
                var result = context.createChannelSplitter(numberOfOutputs);
                Object.setPrototypeOf(result, WebAudioChannelSplitter.prototype);
                connect(node, result);
                return result;
            }
            return _this;
        }
        Object.defineProperty(WebAudioChannelSplitter.prototype, "channels", {
            set: function (channels) {
                var _this = this;
                this.disconnect();
                channels
                    .filter(function (node) { return !!node; })
                    .forEach(function (node, index) {
                    _this.connect(node, index);
                });
            },
            enumerable: false,
            configurable: true
        });
        WebAudioChannelSplitter.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioChannelSplitter;
    }(ChannelSplitterNode));
    WebAudioChannelSplitter.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioChannelSplitter, deps: [{ token: 'numberOfOutputs', attribute: true }, { token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioChannelSplitter.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioChannelSplitter, selector: "[waChannelSplitterNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation" }, providers: [
            {
                provide: AUDIO_NODE,
                useValue: null,
            },
        ], queries: [{ propertyName: "channels", predicate: AUDIO_NODE }], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioChannelSplitter, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waChannelSplitterNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [
                            {
                                provide: AUDIO_NODE,
                                useValue: null,
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['numberOfOutputs']
                        }] }, { type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        }, propDecorators: { channels: [{
                    type: i0.ContentChildren,
                    args: [AUDIO_NODE, { descendants: false }]
                }] } });

    var AudioBufferService = /** @class */ (function () {
        function AudioBufferService(context) {
            this.context = context;
            this.cache = new Map();
        }
        AudioBufferService.prototype.fetch = function (url) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                if (_this.cache.has(url)) {
                    resolve(_this.cache.get(url));
                    return;
                }
                var request = new XMLHttpRequest();
                request.open('GET', url, true);
                request.responseType = 'arraybuffer';
                request.onerror = reject;
                request.onabort = reject;
                request.onload = function () {
                    _this.context.decodeAudioData(request.response, function (buffer) {
                        _this.cache.set(url, buffer);
                        resolve(buffer);
                    }, reject);
                };
                request.send();
            });
        };
        return AudioBufferService;
    }());
    AudioBufferService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: AudioBufferService, deps: [{ token: AUDIO_CONTEXT }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    AudioBufferService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: AudioBufferService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: AudioBufferService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root',
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }];
        } });

    var WebAudioConvolver = /** @class */ (function (_super) {
        __extends(WebAudioConvolver, _super);
        function WebAudioConvolver(audioBufferService, context, node, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context) || this;
                WebAudioConvolver.init(_this, node, audioBufferService);
            }
            else {
                var result = context.createConvolver();
                Object.setPrototypeOf(result, WebAudioConvolver.prototype);
                WebAudioConvolver.init(result, node, audioBufferService);
                return result;
            }
            return _this;
        }
        Object.defineProperty(WebAudioConvolver.prototype, "bufferSetter", {
            set: function (source) {
                this.buffer$.next(source);
            },
            enumerable: false,
            configurable: true
        });
        WebAudioConvolver.prototype.ngOnDestroy = function () {
            this.buffer$.complete();
            this.disconnect();
        };
        WebAudioConvolver.init = function (that, node, audioBufferService) {
            connect(node, that);
            that.buffer$ = new rxjs.Subject();
            that.buffer$
                .pipe(operators.switchMap(function (source) { return typeof source === 'string'
                ? audioBufferService.fetch(source)
                : rxjs.of(source); }))
                .subscribe(function (buffer) {
                that.buffer = buffer;
            });
        };
        return WebAudioConvolver;
    }(ConvolverNode));
    WebAudioConvolver.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioConvolver, deps: [{ token: AudioBufferService }, { token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioConvolver.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioConvolver, selector: "[waConvolverNode]", inputs: { normalize: "normalize", channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", bufferSetter: ["buffer", "bufferSetter"] }, providers: [asAudioNode(WebAudioConvolver)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioConvolver, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waConvolverNode]',
                        exportAs: 'AudioNode',
                        inputs: ['normalize', 'channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioConvolver)],
                    }]
            }], ctorParameters: function () {
            return [{ type: AudioBufferService, decorators: [{
                            type: i0.Inject,
                            args: [AudioBufferService]
                        }] }, { type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        }, propDecorators: { bufferSetter: [{
                    type: i0.Input,
                    args: ['buffer']
                }] } });

    var WebAudioDelay = /** @class */ (function (_super) {
        __extends(WebAudioDelay, _super);
        function WebAudioDelay(context, node, modern, delayTimeArg, maxDelayTimeArg) {
            var _this = this;
            var delayTime = parse(delayTimeArg, 0);
            var maxDelayTime = parse(maxDelayTimeArg, 1);
            if (modern) {
                _this = _super.call(this, context, { delayTime: delayTime, maxDelayTime: maxDelayTime }) || this;
                connect(node, _this);
            }
            else {
                var result = context.createDelay(maxDelayTime);
                Object.setPrototypeOf(result, WebAudioDelay.prototype);
                connect(node, result);
                result.delayTime.value = delayTime;
                return result;
            }
            return _this;
        }
        WebAudioDelay.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        WebAudioDelay.init = function (that, node) {
            connect(node, that);
        };
        return WebAudioDelay;
    }(DelayNode));
    WebAudioDelay.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioDelay, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: CONSTRUCTOR_SUPPORT }, { token: 'delayTime', attribute: true }, { token: 'maxDelayTime', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioDelay.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioDelay, selector: "[waDelayNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", delayTimeParam: ["delayTime", "delayTimeParam"] }, providers: [asAudioNode(WebAudioDelay)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    __decorate([
        audioParam('delayTime')
    ], WebAudioDelay.prototype, "delayTimeParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioDelay, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waDelayNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioDelay)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['delayTime']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['maxDelayTime']
                        }] }];
        }, propDecorators: { delayTimeParam: [{
                    type: i0.Input,
                    args: ['delayTime']
                }] } });

    var WebAudioDynamicsCompressor = /** @class */ (function (_super) {
        __extends(WebAudioDynamicsCompressor, _super);
        function WebAudioDynamicsCompressor(context, node, modern, attackArg, kneeArg, ratioArg, releaseArg, thresholdArg) {
            var _this = this;
            var attack = parse(attackArg, 0.003);
            var knee = parse(kneeArg, 30);
            var ratio = parse(ratioArg, 12);
            var release = parse(releaseArg, 0.25);
            var threshold = parse(thresholdArg, -24);
            if (modern) {
                _this = _super.call(this, context, { attack: attack, knee: knee, ratio: ratio, release: release, threshold: threshold }) || this;
                connect(node, _this);
            }
            else {
                var result = context.createDynamicsCompressor();
                Object.setPrototypeOf(result, WebAudioDynamicsCompressor.prototype);
                connect(node, result);
                result.attack.value = attack;
                result.knee.value = knee;
                result.ratio.value = ratio;
                result.release.value = release;
                result.threshold.value = threshold;
                return result;
            }
            return _this;
        }
        WebAudioDynamicsCompressor.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioDynamicsCompressor;
    }(DynamicsCompressorNode));
    WebAudioDynamicsCompressor.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioDynamicsCompressor, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: CONSTRUCTOR_SUPPORT }, { token: 'attack', attribute: true }, { token: 'knee', attribute: true }, { token: 'ratio', attribute: true }, { token: 'release', attribute: true }, { token: 'threshold', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioDynamicsCompressor.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioDynamicsCompressor, selector: "[waDynamicsCompressorNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", attackParam: ["attack", "attackParam"], kneeParam: ["knee", "kneeParam"], ratioParam: ["ratio", "ratioParam"], releaseParam: ["release", "releaseParam"], thresholdParam: ["threshold", "thresholdParam"] }, providers: [asAudioNode(WebAudioDynamicsCompressor)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    __decorate([
        audioParam('attack')
    ], WebAudioDynamicsCompressor.prototype, "attackParam", void 0);
    __decorate([
        audioParam('knee')
    ], WebAudioDynamicsCompressor.prototype, "kneeParam", void 0);
    __decorate([
        audioParam('ratio')
    ], WebAudioDynamicsCompressor.prototype, "ratioParam", void 0);
    __decorate([
        audioParam('release')
    ], WebAudioDynamicsCompressor.prototype, "releaseParam", void 0);
    __decorate([
        audioParam('threshold')
    ], WebAudioDynamicsCompressor.prototype, "thresholdParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioDynamicsCompressor, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waDynamicsCompressorNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioDynamicsCompressor)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['attack']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['knee']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['ratio']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['release']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['threshold']
                        }] }];
        }, propDecorators: { attackParam: [{
                    type: i0.Input,
                    args: ['attack']
                }], kneeParam: [{
                    type: i0.Input,
                    args: ['knee']
                }], ratioParam: [{
                    type: i0.Input,
                    args: ['ratio']
                }], releaseParam: [{
                    type: i0.Input,
                    args: ['release']
                }], thresholdParam: [{
                    type: i0.Input,
                    args: ['threshold']
                }] } });

    var WebAudioGain = /** @class */ (function (_super) {
        __extends(WebAudioGain, _super);
        function WebAudioGain(context, node, modern, gainArg) {
            var _this = this;
            var gain = parse(gainArg, 1);
            if (modern) {
                _this = _super.call(this, context, { gain: gain }) || this;
                connect(node, _this);
            }
            else {
                var result = context.createGain();
                Object.setPrototypeOf(result, WebAudioGain.prototype);
                connect(node, result);
                result.gain.value = gain;
                return result;
            }
            return _this;
        }
        WebAudioGain.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioGain;
    }(GainNode));
    WebAudioGain.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioGain, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: CONSTRUCTOR_SUPPORT }, { token: 'gain', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioGain.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioGain, selector: "[waGainNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", gainParam: ["gain", "gainParam"] }, providers: [asAudioNode(WebAudioGain)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    __decorate([
        audioParam('gain')
    ], WebAudioGain.prototype, "gainParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioGain, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waGainNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioGain)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['gain']
                        }] }];
        }, propDecorators: { gainParam: [{
                    type: i0.Input,
                    args: ['gain']
                }] } });

    var FEEDBACK_COEFFICIENTS = new i0.InjectionToken('A sequence of feedback coefficients for IIRFilterNode');

    var FEEDFORWARD_COEFFICIENTS = new i0.InjectionToken('A sequence of feedforward coefficients for IIRFilterNode');

    var WebAudioIIRFilter = /** @class */ (function (_super) {
        __extends(WebAudioIIRFilter, _super);
        function WebAudioIIRFilter(feedback, feedforward, context, modern, node) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context, { feedback: feedback, feedforward: feedforward }) || this;
                connect(node, _this);
            }
            else {
                var result = context.createIIRFilter(feedback, feedforward);
                Object.setPrototypeOf(result, WebAudioIIRFilter.prototype);
                connect(node, result);
                return result;
            }
            return _this;
        }
        WebAudioIIRFilter.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioIIRFilter;
    }(IIRFilterNode));
    WebAudioIIRFilter.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioIIRFilter, deps: [{ token: FEEDBACK_COEFFICIENTS }, { token: FEEDFORWARD_COEFFICIENTS }, { token: AUDIO_CONTEXT }, { token: CONSTRUCTOR_SUPPORT }, { token: AUDIO_NODE, skipSelf: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioIIRFilter.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioIIRFilter, selector: "[waIIRFilterNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation" }, providers: [asAudioNode(WebAudioIIRFilter)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioIIRFilter, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waIIRFilterNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioIIRFilter)],
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [FEEDBACK_COEFFICIENTS]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [FEEDFORWARD_COEFFICIENTS]
                        }] }, { type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }];
        } });

    var WebAudioPanner = /** @class */ (function (_super) {
        __extends(WebAudioPanner, _super);
        function WebAudioPanner(context, node, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context) || this;
                connect(node, _this);
            }
            else {
                var result = context.createPanner();
                Object.setPrototypeOf(result, WebAudioPanner.prototype);
                connect(node, result);
                return result;
            }
            return _this;
        }
        WebAudioPanner.prototype.ngOnChanges = function () {
            if (this.positionX instanceof AudioParam) {
                return;
            }
            // Fallback for older browsers
            this.setOrientation(fallbackAudioParam(this.orientationXParam), fallbackAudioParam(this.orientationYParam), fallbackAudioParam(this.orientationZParam));
            this.setPosition(fallbackAudioParam(this.positionXParam), fallbackAudioParam(this.positionYParam), fallbackAudioParam(this.positionZParam));
        };
        WebAudioPanner.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioPanner;
    }(PannerNode));
    WebAudioPanner.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioPanner, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioPanner.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioPanner, selector: "[waPannerNode]", inputs: { coneInnerAngle: "coneInnerAngle", coneOuterAngle: "coneOuterAngle", coneOuterGain: "coneOuterGain", distanceModel: "distanceModel", maxDistance: "maxDistance", panningModel: "panningModel", refDistance: "refDistance", rolloffFactor: "rolloffFactor", channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", orientationXParam: "orientationXParam", orientationYParam: "orientationYParam", orientationZParam: "orientationZParam", positionXParam: "positionXParam", positionYParam: "positionYParam", positionZParam: "positionZParam" }, providers: [asAudioNode(WebAudioPanner)], exportAs: ["AudioNode"], usesInheritance: true, usesOnChanges: true, ngImport: i0__namespace });
    __decorate([
        audioParam('orientationX')
    ], WebAudioPanner.prototype, "orientationXParam", void 0);
    __decorate([
        audioParam('orientationY')
    ], WebAudioPanner.prototype, "orientationYParam", void 0);
    __decorate([
        audioParam('orientationZ')
    ], WebAudioPanner.prototype, "orientationZParam", void 0);
    __decorate([
        audioParam('positionX')
    ], WebAudioPanner.prototype, "positionXParam", void 0);
    __decorate([
        audioParam('positionY')
    ], WebAudioPanner.prototype, "positionYParam", void 0);
    __decorate([
        audioParam('positionZ')
    ], WebAudioPanner.prototype, "positionZParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioPanner, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waPannerNode]',
                        exportAs: 'AudioNode',
                        inputs: [
                            'coneInnerAngle',
                            'coneOuterAngle',
                            'coneOuterGain',
                            'distanceModel',
                            'maxDistance',
                            'panningModel',
                            'refDistance',
                            'rolloffFactor',
                            'channelCount',
                            'channelCountMode',
                            'channelInterpretation',
                        ],
                        providers: [asAudioNode(WebAudioPanner)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        }, propDecorators: { orientationXParam: [{
                    type: i0.Input
                }], orientationYParam: [{
                    type: i0.Input
                }], orientationZParam: [{
                    type: i0.Input
                }], positionXParam: [{
                    type: i0.Input
                }], positionYParam: [{
                    type: i0.Input
                }], positionZParam: [{
                    type: i0.Input
                }] } });

    var WebAudioScriptProcessor = /** @class */ (function (_super) {
        __extends(WebAudioScriptProcessor, _super);
        function WebAudioScriptProcessor(bufferSize, numberOfInputChannels, numberOfOutputChannels, context, node) {
            var _this = this;
            try {
                var result = context.createScriptProcessor(parseInt(bufferSize || '', 10) || 0, parseInt(numberOfInputChannels || '', 10) || 2, parseInt(numberOfOutputChannels || '', 10) || 2);
                Object.setPrototypeOf(result, WebAudioScriptProcessor.prototype);
                connect(node, result);
                var audioprocess_1 = new i0.EventEmitter();
                result.audioprocess = audioprocess_1;
                result.onaudioprocess = function (e) { return audioprocess_1.emit(e); };
                return result;
            }
            catch (_) {
                // noop
            }
            _this = _super.call(this) || this;
            return _this;
        }
        WebAudioScriptProcessor.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioScriptProcessor;
    }(ScriptProcessorNode));
    WebAudioScriptProcessor.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioScriptProcessor, deps: [{ token: 'bufferSize', attribute: true }, { token: 'numberOfInputChannels', attribute: true }, { token: 'numberOfOutputChannels', attribute: true }, { token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioScriptProcessor.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioScriptProcessor, selector: "[waScriptProcessorNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation" }, outputs: { audioprocess: "audioprocess" }, providers: [asAudioNode(WebAudioScriptProcessor)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioScriptProcessor, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waScriptProcessorNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioScriptProcessor)],
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['bufferSize']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['numberOfInputChannels']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['numberOfOutputChannels']
                        }] }, { type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }];
        }, propDecorators: { audioprocess: [{
                    type: i0.Output
                }] } });

    var WebAudioStereoPanner = /** @class */ (function (_super) {
        __extends(WebAudioStereoPanner, _super);
        function WebAudioStereoPanner(context, node, panArg) {
            var _this = this;
            var pan = parse(panArg, 0);
            try {
                new StereoPannerNode(context);
            }
            catch (_a) {
                var result = context.createPanner();
                Object.setPrototypeOf(result, WebAudioStereoPanner.prototype);
                result.fallbackToPannerNode(fallbackAudioParam(pan));
                connect(node, result);
                return result;
            }
            _this = _super.call(this, context, { pan: pan }) || this;
            connect(node, _this);
            return _this;
        }
        Object.defineProperty(WebAudioStereoPanner.prototype, "panParam", {
            set: function (pan) {
                if ('setPosition' in this) {
                    /** fallback for browsers not supporting {@link StereoPannerNode} */
                    // @ts-ignore
                    this.fallbackToPannerNode(fallbackAudioParam(pan));
                }
                else {
                    processAudioParam(this.pan, pan, this.context.currentTime);
                }
            },
            enumerable: false,
            configurable: true
        });
        WebAudioStereoPanner.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        // @ts-ignore
        WebAudioStereoPanner.prototype.fallbackToPannerNode = function (pan) {
            var xDeg = pan * 100;
            var zDeg = xDeg > 0 ? 270 - xDeg : xDeg + 90;
            var x = Math.sin(xDeg * (Math.PI / 180));
            var z = Math.sin(zDeg * (Math.PI / 180));
            // @ts-ignore
            this.setPosition(x, 0, z);
        };
        return WebAudioStereoPanner;
    }(StereoPannerNode));
    WebAudioStereoPanner.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioStereoPanner, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: 'pan', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioStereoPanner.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioStereoPanner, selector: "[waStereoPannerNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", panParam: ["pan", "panParam"] }, providers: [asAudioNode(WebAudioStereoPanner)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioStereoPanner, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waStereoPannerNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioStereoPanner)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['pan']
                        }] }];
        }, propDecorators: { panParam: [{
                    type: i0.Input,
                    args: ['pan']
                }] } });

    var WebAudioWaveShaper = /** @class */ (function (_super) {
        __extends(WebAudioWaveShaper, _super);
        function WebAudioWaveShaper(context, node, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context) || this;
                connect(node, _this);
            }
            else {
                var result = context.createWaveShaper();
                Object.setPrototypeOf(result, WebAudioWaveShaper.prototype);
                connect(node, result);
                return result;
            }
            return _this;
        }
        WebAudioWaveShaper.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioWaveShaper;
    }(WaveShaperNode));
    WebAudioWaveShaper.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioWaveShaper, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioWaveShaper.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioWaveShaper, selector: "[waWaveShaperNode]", inputs: { oversample: "oversample", curve: "curve", channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation" }, providers: [asAudioNode(WebAudioWaveShaper)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioWaveShaper, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waWaveShaperNode]',
                        exportAs: 'AudioNode',
                        inputs: [
                            'oversample',
                            'curve',
                            'channelCount',
                            'channelCountMode',
                            'channelInterpretation',
                        ],
                        providers: [asAudioNode(WebAudioWaveShaper)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        } });

    var WebAudioWorklet = /** @class */ (function (_super) {
        __extends(WebAudioWorklet, _super);
        function WebAudioWorklet(context, node, name) {
            var _this = _super.call(this, context, name) || this;
            _this.processorerror = new i0.EventEmitter();
            _this.onprocessorerror = function () { return _this.processorerror.emit(); };
            connect(node, _this);
            return _this;
        }
        WebAudioWorklet.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioWorklet;
    }(AudioWorkletNode));
    WebAudioWorklet.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioWorklet, deps: [{ token: AUDIO_CONTEXT }, { token: AUDIO_NODE, skipSelf: true }, { token: 'name', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioWorklet.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioWorklet, selector: "[waAudioWorkletNode][name]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation" }, outputs: { processorerror: "processorerror" }, providers: [asAudioNode(WebAudioWorklet)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioWorklet, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waAudioWorkletNode][name]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioWorklet)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: AudioNode, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Inject,
                            args: [AUDIO_NODE]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['name']
                        }] }];
        }, propDecorators: { processorerror: [{
                    type: i0.Output
                }] } });

    var WebAudioParamPipe = /** @class */ (function () {
        function WebAudioParamPipe() {
        }
        /**
         * Creates {@link AudioParamAutomation} to use with {@link AudioParam} inputs
         *
         * @param value target value
         * @param duration duration of the automation
         * @param mode either instant for given duration or linear/exponential ramp
         */
        WebAudioParamPipe.prototype.transform = function (value, duration, mode) {
            if (mode === void 0) { mode = 'exponential'; }
            return value instanceof Array
                ? {
                    value: value,
                    duration: duration,
                }
                : {
                    value: value,
                    duration: duration,
                    mode: mode,
                };
        };
        return WebAudioParamPipe;
    }());
    WebAudioParamPipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioParamPipe, deps: [], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    WebAudioParamPipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioParamPipe, name: "waAudioParam" });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioParamPipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'waAudioParam',
                    }]
            }] });

    var WebAudioPeriodicWavePipe = /** @class */ (function () {
        function WebAudioPeriodicWavePipe(context) {
            this.context = context;
        }
        /**
         * Creates {@link PeriodicWave} to use with {@link OscillatorNode}
         *
         * @param real cosine terms (traditionally the A terms)
         * @param imag sine terms (traditionally the B terms)
         * @param disableNormalization see {@lin PeriodicWaveConstraints}
         */
        WebAudioPeriodicWavePipe.prototype.transform = function (real, imag, disableNormalization) {
            return this.context.createPeriodicWave(new Float32Array(real), imag ? new Float32Array(imag) : new Float32Array(real.length), {
                disableNormalization: !!disableNormalization,
            });
        };
        return WebAudioPeriodicWavePipe;
    }());
    WebAudioPeriodicWavePipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioPeriodicWavePipe, deps: [{ token: AUDIO_CONTEXT }], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    WebAudioPeriodicWavePipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioPeriodicWavePipe, name: "waPeriodicWave" });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioPeriodicWavePipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'waPeriodicWave',
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }];
        } });

    var WebAudioBufferSource = /** @class */ (function (_super) {
        __extends(WebAudioBufferSource, _super);
        function WebAudioBufferSource(audioBufferService, context, modern, autoplay, detuneArg, playbackRateArg) {
            var _this = this;
            var detune = parse(detuneArg, 0);
            var playbackRate = parse(playbackRateArg, 1);
            if (modern) {
                _this = _super.call(this, context, { detune: detune, playbackRate: playbackRate }) || this;
                WebAudioBufferSource.init(_this, null, autoplay, audioBufferService);
            }
            else {
                var result = context.createBufferSource();
                Object.setPrototypeOf(WebAudioBufferSource.prototype, Object.getPrototypeOf(result));
                Object.setPrototypeOf(result, WebAudioBufferSource.prototype);
                result.playbackRate.value = playbackRate;
                WebAudioBufferSource.init(result, null, autoplay, audioBufferService);
                return result;
            }
            return _this;
        }
        Object.defineProperty(WebAudioBufferSource.prototype, "bufferSetter", {
            set: function (source) {
                this.buffer$.next(source);
            },
            enumerable: false,
            configurable: true
        });
        WebAudioBufferSource.prototype.ngOnDestroy = function () {
            this.buffer$.complete();
            try {
                this.stop();
            }
            catch (_a) {
                // noop
            }
            this.disconnect();
        };
        WebAudioBufferSource.init = function (that, _node, autoplay, audioBufferService) {
            if (autoplay !== null) {
                that.start();
            }
            var ended = new i0.EventEmitter();
            that.ended = ended;
            that.onended = function () { return ended.emit(); };
            that.buffer$ = new rxjs.Subject();
            that.buffer$
                .pipe(operators.switchMap(function (source) { return typeof source === 'string'
                ? audioBufferService.fetch(source)
                : rxjs.of(source); }))
                .subscribe(function (buffer) {
                that.buffer = buffer;
            });
        };
        return WebAudioBufferSource;
    }(AudioBufferSourceNode));
    WebAudioBufferSource.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioBufferSource, deps: [{ token: AudioBufferService }, { token: AUDIO_CONTEXT }, { token: CONSTRUCTOR_SUPPORT }, { token: 'autoplay', attribute: true }, { token: 'detune', attribute: true }, { token: 'playbackRate', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioBufferSource.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioBufferSource, selector: "[waAudioBufferSourceNode]", inputs: { loop: "loop", loopStart: "loopStart", loopEnd: "loopEnd", channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", bufferSetter: ["buffer", "bufferSetter"], detuneParam: ["detune", "detuneParam"], playbackRateParam: ["playbackRate", "playbackRateParam"] }, outputs: { ended: "ended" }, providers: [asAudioNode(WebAudioBufferSource)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    __decorate([
        audioParam('detune')
    ], WebAudioBufferSource.prototype, "detuneParam", void 0);
    __decorate([
        audioParam('playbackRate')
    ], WebAudioBufferSource.prototype, "playbackRateParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioBufferSource, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waAudioBufferSourceNode]',
                        exportAs: 'AudioNode',
                        inputs: [
                            'loop',
                            'loopStart',
                            'loopEnd',
                            'channelCount',
                            'channelCountMode',
                            'channelInterpretation',
                        ],
                        providers: [asAudioNode(WebAudioBufferSource)],
                    }]
            }], ctorParameters: function () {
            return [{ type: AudioBufferService, decorators: [{
                            type: i0.Inject,
                            args: [AudioBufferService]
                        }] }, { type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['autoplay']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['detune']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['playbackRate']
                        }] }];
        }, propDecorators: { bufferSetter: [{
                    type: i0.Input,
                    args: ['buffer']
                }], detuneParam: [{
                    type: i0.Input,
                    args: ['detune']
                }], playbackRateParam: [{
                    type: i0.Input,
                    args: ['playbackRate']
                }], ended: [{
                    type: i0.Output
                }] } });

    var WebAudioConstantSource = /** @class */ (function (_super) {
        __extends(WebAudioConstantSource, _super);
        function WebAudioConstantSource(context, autoplay, offset) {
            var _this = _super.call(this, context, {
                offset: parse(offset, 0),
            }) || this;
            _this.ended = new i0.EventEmitter();
            _this.onended = function () { return _this.ended.emit(); };
            if (autoplay !== null) {
                _this.start();
            }
            return _this;
        }
        WebAudioConstantSource.prototype.ngOnDestroy = function () {
            try {
                this.stop();
            }
            catch (_a) {
                // noop
            }
            this.disconnect();
        };
        return WebAudioConstantSource;
    }(ConstantSourceNode));
    WebAudioConstantSource.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioConstantSource, deps: [{ token: AUDIO_CONTEXT }, { token: 'autoplay', attribute: true }, { token: 'offset', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioConstantSource.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioConstantSource, selector: "[waConstantSourceNode]", inputs: { channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", offsetParam: ["offset", "offsetParam"] }, outputs: { ended: "ended" }, providers: [asAudioNode(WebAudioConstantSource)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    __decorate([
        audioParam('offset')
    ], WebAudioConstantSource.prototype, "offsetParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioConstantSource, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waConstantSourceNode]',
                        exportAs: 'AudioNode',
                        inputs: ['channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioConstantSource)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['autoplay']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['offset']
                        }] }];
        }, propDecorators: { offsetParam: [{
                    type: i0.Input,
                    args: ['offset']
                }], ended: [{
                    type: i0.Output
                }] } });

    var WebAudioMediaSource = /** @class */ (function (_super) {
        __extends(WebAudioMediaSource, _super);
        function WebAudioMediaSource(context, modern, _a) {
            var nativeElement = _a.nativeElement;
            var _this = this;
            if (modern) {
                _this = _super.call(this, context, { mediaElement: nativeElement }) || this;
            }
            else {
                var result = context.createMediaElementSource(nativeElement);
                Object.setPrototypeOf(result, WebAudioMediaSource.prototype);
                return result;
            }
            return _this;
        }
        WebAudioMediaSource.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioMediaSource;
    }(MediaElementAudioSourceNode));
    WebAudioMediaSource.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioMediaSource, deps: [{ token: AUDIO_CONTEXT }, { token: CONSTRUCTOR_SUPPORT }, { token: i0.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioMediaSource.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioMediaSource, selector: "audio[waMediaElementAudioSourceNode], video[waMediaElementAudioSourceNode]", providers: [asAudioNode(WebAudioMediaSource)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioMediaSource, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: 'audio[waMediaElementAudioSourceNode], video[waMediaElementAudioSourceNode]',
                        exportAs: 'AudioNode',
                        providers: [asAudioNode(WebAudioMediaSource)],
                    }]
            }], ctorParameters: function () {
            return [{ type: AudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: i0__namespace.ElementRef, decorators: [{
                            type: i0.Inject,
                            args: [i0.ElementRef]
                        }] }];
        } });

    var MEDIA_STREAM = new i0.InjectionToken('MediaStream for MediaStreamAudioSourceNode');

    var WebAudioMediaStreamSource = /** @class */ (function (_super) {
        __extends(WebAudioMediaStreamSource, _super);
        function WebAudioMediaStreamSource(mediaStream, context, modern) {
            var _this = this;
            if (modern) {
                _this = _super.call(this, context, { mediaStream: mediaStream }) || this;
            }
            else {
                var result = context.createMediaStreamSource(mediaStream);
                Object.setPrototypeOf(result, WebAudioMediaStreamSource.prototype);
                return result;
            }
            return _this;
        }
        WebAudioMediaStreamSource.prototype.ngOnDestroy = function () {
            this.disconnect();
        };
        return WebAudioMediaStreamSource;
    }(MediaStreamAudioSourceNode));
    WebAudioMediaStreamSource.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioMediaStreamSource, deps: [{ token: MEDIA_STREAM }, { token: AUDIO_CONTEXT }, { token: CONSTRUCTOR_SUPPORT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioMediaStreamSource.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioMediaStreamSource, selector: "[waMediaStreamAudioSourceNode]", providers: [asAudioNode(WebAudioMediaStreamSource)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioMediaStreamSource, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waMediaStreamAudioSourceNode]',
                        exportAs: 'AudioNode',
                        providers: [asAudioNode(WebAudioMediaStreamSource)],
                    }]
            }], ctorParameters: function () {
            return [{ type: MediaStream, decorators: [{
                            type: i0.Inject,
                            args: [MEDIA_STREAM]
                        }] }, { type: AudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }];
        } });

    var WebAudioOscillator = /** @class */ (function (_super) {
        __extends(WebAudioOscillator, _super);
        function WebAudioOscillator(context, modern, autoplay, detuneArg, frequencyArg) {
            var _this = this;
            var detune = parse(detuneArg, 0);
            var frequency = parse(frequencyArg, 440);
            if (modern) {
                _this = _super.call(this, context, { detune: detune, frequency: frequency }) || this;
                WebAudioOscillator.init(_this, null, autoplay);
            }
            else {
                var result = context.createOscillator();
                Object.setPrototypeOf(WebAudioOscillator.prototype, Object.getPrototypeOf(result));
                Object.setPrototypeOf(result, WebAudioOscillator.prototype);
                result.detune.value = detune;
                result.frequency.value = frequency;
                WebAudioOscillator.init(result, null, autoplay);
                return result;
            }
            return _this;
        }
        Object.defineProperty(WebAudioOscillator.prototype, "periodicWave", {
            set: function (periodicWave) {
                this.setPeriodicWave(periodicWave);
            },
            enumerable: false,
            configurable: true
        });
        WebAudioOscillator.prototype.ngOnDestroy = function () {
            try {
                this.stop();
            }
            catch (_a) {
                // noop
            }
            this.disconnect();
        };
        WebAudioOscillator.init = function (that, node, autoplay) {
            connect(node, that);
            if (autoplay !== null) {
                that.start();
            }
            var ended = new i0.EventEmitter();
            that.ended = ended;
            that.onended = function () { return ended.emit(); };
        };
        return WebAudioOscillator;
    }(OscillatorNode));
    WebAudioOscillator.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioOscillator, deps: [{ token: AUDIO_CONTEXT }, { token: CONSTRUCTOR_SUPPORT }, { token: 'autoplay', attribute: true }, { token: 'detune', attribute: true }, { token: 'frequency', attribute: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    WebAudioOscillator.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: WebAudioOscillator, selector: "[waOscillatorNode]", inputs: { type: "type", channelCount: "channelCount", channelCountMode: "channelCountMode", channelInterpretation: "channelInterpretation", periodicWave: "periodicWave", detuneParam: ["detune", "detuneParam"], frequencyParam: ["frequency", "frequencyParam"] }, outputs: { ended: "ended" }, providers: [asAudioNode(WebAudioOscillator)], exportAs: ["AudioNode"], usesInheritance: true, ngImport: i0__namespace });
    __decorate([
        audioParam('detune')
    ], WebAudioOscillator.prototype, "detuneParam", void 0);
    __decorate([
        audioParam('frequency')
    ], WebAudioOscillator.prototype, "frequencyParam", void 0);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioOscillator, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[waOscillatorNode]',
                        exportAs: 'AudioNode',
                        inputs: ['type', 'channelCount', 'channelCountMode', 'channelInterpretation'],
                        providers: [asAudioNode(WebAudioOscillator)],
                    }]
            }], ctorParameters: function () {
            return [{ type: BaseAudioContext, decorators: [{
                            type: i0.Inject,
                            args: [AUDIO_CONTEXT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONSTRUCTOR_SUPPORT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['autoplay']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['detune']
                        }] }, { type: undefined, decorators: [{
                            type: i0.Attribute,
                            args: ['frequency']
                        }] }];
        }, propDecorators: { periodicWave: [{
                    type: i0.Input
                }], detuneParam: [{
                    type: i0.Input,
                    args: ['detune']
                }], frequencyParam: [{
                    type: i0.Input,
                    args: ['frequency']
                }], ended: [{
                    type: i0.Output
                }] } });

    var AUDIO_WORKLET_PROCESSORS = new i0.InjectionToken('Web Audio API worklet processors paths', {
        providedIn: 'root',
        factory: function () { return []; },
    });

    var AUDIO_WORKLET_SUPPORT = new i0.InjectionToken('AudioWorklet browser support', {
        factory: function () { return !!i0.inject(AUDIO_CONTEXT).audioWorklet; },
    });

    var AUDIO_WORKLET_PROCESSORS_READY = new i0.InjectionToken('Web Audio API worklet processors resolution promise', {
        providedIn: 'root',
        factory: function () {
            var context = i0.inject(AUDIO_CONTEXT);
            var processors = i0.inject(AUDIO_WORKLET_PROCESSORS);
            if (!i0.inject(AUDIO_WORKLET_SUPPORT)) {
                return Promise.reject('AudioWorklet is not supported').catch(function () { return false; });
            }
            return Promise.all(processors.map(function (processor) { return context.audioWorklet.addModule(processor); })).then(function () { return true; });
        },
    });

    var WEB_AUDIO_SUPPORT = new i0.InjectionToken('Web Audio API support', {
        providedIn: 'root',
        factory: function () { return !!AudioContext; },
    });

    var WebAudioModule = /** @class */ (function () {
        function WebAudioModule() {
        }
        return WebAudioModule;
    }());
    WebAudioModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    WebAudioModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioModule, declarations: [WebAudioContext,
            WebAudioChannel,
            WebAudioDestination,
            WebAudioListener,
            WebAudioOfflineContext,
            WebAudioOutput,
            WebAudioMediaStreamDestination,
            WebAudioBufferSource,
            WebAudioConstantSource,
            WebAudioMediaSource,
            WebAudioMediaStreamSource,
            WebAudioOscillator,
            WebAudioAnalyser,
            WebAudioBiquadFilter,
            WebAudioChannelSplitter,
            WebAudioChannelMerger,
            WebAudioConvolver,
            WebAudioDelay,
            WebAudioDynamicsCompressor,
            WebAudioGain,
            WebAudioIIRFilter,
            WebAudioPanner,
            WebAudioScriptProcessor,
            WebAudioStereoPanner,
            WebAudioWaveShaper,
            WebAudioWorklet,
            WebAudioParamPipe,
            WebAudioPeriodicWavePipe], exports: [WebAudioContext,
            WebAudioChannel,
            WebAudioDestination,
            WebAudioListener,
            WebAudioOfflineContext,
            WebAudioOutput,
            WebAudioMediaStreamDestination,
            WebAudioBufferSource,
            WebAudioConstantSource,
            WebAudioMediaSource,
            WebAudioMediaStreamSource,
            WebAudioOscillator,
            WebAudioAnalyser,
            WebAudioBiquadFilter,
            WebAudioChannelSplitter,
            WebAudioChannelMerger,
            WebAudioConvolver,
            WebAudioDelay,
            WebAudioDynamicsCompressor,
            WebAudioGain,
            WebAudioIIRFilter,
            WebAudioPanner,
            WebAudioScriptProcessor,
            WebAudioStereoPanner,
            WebAudioWaveShaper,
            WebAudioWorklet,
            WebAudioParamPipe,
            WebAudioPeriodicWavePipe] });
    WebAudioModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioModule });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: WebAudioModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            WebAudioContext,
                            WebAudioChannel,
                            WebAudioDestination,
                            WebAudioListener,
                            WebAudioOfflineContext,
                            WebAudioOutput,
                            WebAudioMediaStreamDestination,
                            WebAudioBufferSource,
                            WebAudioConstantSource,
                            WebAudioMediaSource,
                            WebAudioMediaStreamSource,
                            WebAudioOscillator,
                            WebAudioAnalyser,
                            WebAudioBiquadFilter,
                            WebAudioChannelSplitter,
                            WebAudioChannelMerger,
                            WebAudioConvolver,
                            WebAudioDelay,
                            WebAudioDynamicsCompressor,
                            WebAudioGain,
                            WebAudioIIRFilter,
                            WebAudioPanner,
                            WebAudioScriptProcessor,
                            WebAudioStereoPanner,
                            WebAudioWaveShaper,
                            WebAudioWorklet,
                            WebAudioParamPipe,
                            WebAudioPeriodicWavePipe,
                        ],
                        exports: [
                            WebAudioContext,
                            WebAudioChannel,
                            WebAudioDestination,
                            WebAudioListener,
                            WebAudioOfflineContext,
                            WebAudioOutput,
                            WebAudioMediaStreamDestination,
                            WebAudioBufferSource,
                            WebAudioConstantSource,
                            WebAudioMediaSource,
                            WebAudioMediaStreamSource,
                            WebAudioOscillator,
                            WebAudioAnalyser,
                            WebAudioBiquadFilter,
                            WebAudioChannelSplitter,
                            WebAudioChannelMerger,
                            WebAudioConvolver,
                            WebAudioDelay,
                            WebAudioDynamicsCompressor,
                            WebAudioGain,
                            WebAudioIIRFilter,
                            WebAudioPanner,
                            WebAudioScriptProcessor,
                            WebAudioStereoPanner,
                            WebAudioWaveShaper,
                            WebAudioWorklet,
                            WebAudioParamPipe,
                            WebAudioPeriodicWavePipe,
                        ],
                    }]
            }] });

    /**
     * Public API Surface of @ng-web-apis/audio
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AUDIO_CONTEXT = AUDIO_CONTEXT;
    exports.AUDIO_NODE = AUDIO_NODE;
    exports.AUDIO_WORKLET_PROCESSORS = AUDIO_WORKLET_PROCESSORS;
    exports.AUDIO_WORKLET_PROCESSORS_READY = AUDIO_WORKLET_PROCESSORS_READY;
    exports.AUDIO_WORKLET_SUPPORT = AUDIO_WORKLET_SUPPORT;
    exports.AudioBufferService = AudioBufferService;
    exports.FEEDBACK_COEFFICIENTS = FEEDBACK_COEFFICIENTS;
    exports.FEEDFORWARD_COEFFICIENTS = FEEDFORWARD_COEFFICIENTS;
    exports.MEDIA_STREAM = MEDIA_STREAM;
    exports.WEB_AUDIO_SUPPORT = WEB_AUDIO_SUPPORT;
    exports.WebAudioAnalyser = WebAudioAnalyser;
    exports.WebAudioBiquadFilter = WebAudioBiquadFilter;
    exports.WebAudioBufferSource = WebAudioBufferSource;
    exports.WebAudioChannel = WebAudioChannel;
    exports.WebAudioChannelMerger = WebAudioChannelMerger;
    exports.WebAudioChannelSplitter = WebAudioChannelSplitter;
    exports.WebAudioConstantSource = WebAudioConstantSource;
    exports.WebAudioContext = WebAudioContext;
    exports.WebAudioConvolver = WebAudioConvolver;
    exports.WebAudioDelay = WebAudioDelay;
    exports.WebAudioDestination = WebAudioDestination;
    exports.WebAudioDynamicsCompressor = WebAudioDynamicsCompressor;
    exports.WebAudioGain = WebAudioGain;
    exports.WebAudioIIRFilter = WebAudioIIRFilter;
    exports.WebAudioListener = WebAudioListener;
    exports.WebAudioMediaSource = WebAudioMediaSource;
    exports.WebAudioMediaStreamDestination = WebAudioMediaStreamDestination;
    exports.WebAudioMediaStreamSource = WebAudioMediaStreamSource;
    exports.WebAudioModule = WebAudioModule;
    exports.WebAudioOfflineContext = WebAudioOfflineContext;
    exports.WebAudioOscillator = WebAudioOscillator;
    exports.WebAudioOutput = WebAudioOutput;
    exports.WebAudioPanner = WebAudioPanner;
    exports.WebAudioParamPipe = WebAudioParamPipe;
    exports.WebAudioPeriodicWavePipe = WebAudioPeriodicWavePipe;
    exports.WebAudioScriptProcessor = WebAudioScriptProcessor;
    exports.WebAudioStereoPanner = WebAudioStereoPanner;
    exports.WebAudioWaveShaper = WebAudioWaveShaper;
    exports.WebAudioWorklet = WebAudioWorklet;
    exports.asAudioNode = asAudioNode;
    exports.audioParam = audioParam;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng-web-apis-audio.umd.js.map
