import { EventEmitter, OnDestroy } from '@angular/core';
import { Subject } from 'rxjs';
import { AudioBufferService } from '../services/audio-buffer.service';
import { AudioParamInput } from '../types/audio-param-input';
import * as i0 from "@angular/core";
export declare class WebAudioBufferSource extends AudioBufferSourceNode implements OnDestroy {
    set bufferSetter(source: AudioBuffer | null | string);
    detuneParam?: AudioParamInput;
    playbackRateParam?: AudioParamInput;
    ended?: EventEmitter<void>;
    buffer$: Subject<AudioBuffer | null | string>;
    constructor(audioBufferService: AudioBufferService, context: BaseAudioContext, modern: boolean, autoplay: string | null, detuneArg: string | null, playbackRateArg: string | null);
    ngOnDestroy(): void;
    static init(that: WebAudioBufferSource, _node: AudioNode | null, autoplay: string | null, audioBufferService: AudioBufferService): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<WebAudioBufferSource, [null, null, null, { attribute: "autoplay"; }, { attribute: "detune"; }, { attribute: "playbackRate"; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<WebAudioBufferSource, "[waAudioBufferSourceNode]", ["AudioNode"], { "loop": "loop"; "loopStart": "loopStart"; "loopEnd": "loopEnd"; "channelCount": "channelCount"; "channelCountMode": "channelCountMode"; "channelInterpretation": "channelInterpretation"; "bufferSetter": "buffer"; "detuneParam": "detune"; "playbackRateParam": "playbackRate"; }, { "ended": "ended"; }, never>;
}
